MODULE ByteManipulation;

IMPORT Out;

PROCEDURE Int16ToBytes(addr: INTEGER; VAR msb, lsb: BYTE);
BEGIN
  lsb := addr;
  msb := ROR(addr, 8);
END Int16ToBytes;

PROCEDURE BytesToInt16(msb, lsb: BYTE; VAR addr: INTEGER);
BEGIN
  addr := LSL(msb, 8) + lsb;
END BytesToInt16;

PROCEDURE Test*;
VAR
  addr: INTEGER;
  msb, lsb: BYTE;
BEGIN
  addr := 0AABBCCDDH;
  Int16ToBytes(addr, msb, lsb);
  Out.Hex(msb, 10); Out.Hex(lsb, 10); Out.Ln;
  msb := 0AAH;
  lsb := 0BBH;
  BytesToInt16(msb, lsb, addr);
  Out.Hex(addr, 10); Out.Ln
END Test;

END ByteManipulation.


